/*
 * @Description: 
 * @Author: wujc
 * @Date: 2021-09-02
 * @LastEditors: wujc
 * @LastEditTime: 2021-09-02
 */
function indexctrl() {
    //temp global val
    gatespace_project = new gatespace.project();
    //temp global val
    objctrl = new Object();

    objctrl.expansion = null;
    objctrl.buzzer = false;

    objctrl.warning = false;

    objctrl.startctrl = async() => {
        if (!await gatespace_project.startctrl()) return false;
        await objctrl.get_expansion_info();

        // 切换子页面时，判断是否登录
        $("#side-menu a.single").click(async() => {
            if (!await gatespace_project.auto_login_detection()) return false;
        });
        $("#alarmIcon").parent().click(async() => {
            if (!await gatespace_project.auto_login_detection()) return false;
        });
        
        if(objctrl.expansion == "mob") objctrl.get_builtin_livolt();

        objctrl.get_project();
        objctrl.init_alarm();
    };

    objctrl.get_project = async () => {
        var data, msg;
        data = { 'file': 'sys' };
        msg = await gatespace_project.userproject(0, 0, data);
        objctrl.buzzer = msg.response.Info.buzzer == '1' ? true : false;
    };
    objctrl.get_expansion_info = async () => {
        var data, msg;
        data = { 'file': 'sn' };
        msg = await gatespace_project.userproject(0, 0, data);
        // objctrl.global = msg.response['global'];
        // objctrl.language = msg.response['language'];
        objctrl.expansion = msg.response['expansion'];
    };

    // 告警显示
    objctrl.init_alarm = function () {
        startPublicAlarm();
    };

    
    objctrl.get_builtin_livolt = () => {
        $.ajax({
            url: 'getBuiltInLiVolt.php',
            type: 'post',
            async: true,
            dataType: 'json',
            timeout: 2000,
            success: function(msg) {
                if(msg.result < 1.05 && msg.result != 0) {
                    if(!objctrl.warning) layerInfoOpen(null, lan('BuiltInLiVoltTooLow'), null, null, null, 0);
                    objctrl.warning = true;
                }else if(msg.result > 1.05) {
                    layer.closeAll();
                    objctrl.warning = false;
                }
            },
            error: function(errmsg, status, thrown) {
            }
        });
        
        setTimeout(objctrl.get_builtin_livolt, 5000);
    };

    return objctrl;
};

/*-------------------------------------------------------------------- */
var timeout_alarmCount, timeout_alarmIcon;
var alarmIconFlg = 0;
var alarmCount = 0;

//***************************** alarm***************************** */
function startPublicAlarm() {
    clearPublicAlarm();
    
    setTimeout(() => {
        getAlarmCount();

        timeout_alarmIcon = setInterval(() => {
            flickerAlarmIcon();
        }, 1000);
    }, 1000);
}

function clearPublicAlarm() {
    clearTimeout(timeout_alarmCount);
    clearInterval(timeout_alarmIcon);
}

function getAlarmCount() {
    var data = { 'file': 'alarm' };
    gatespace_project.userproject(3, 1, data).then(async (msg) => {
        // if (!gatespace_project.handle_response_error(objctrl.get_alarm, msg, 'ContactAdmin', '00202')) return;
        // if (!gatespace_project.handle_response_exists('DeviceNotComm', '00202', msg.response)) return;

        var data = msg.response;
        var count = 0;
        for(let i = 0; i < data.length; i++) {
            if(data[i].Status == 0) {
                count++;
            }
        }
        alarmCount = count;

    }).catch(function (){
    });

    timeout_alarmCount = setTimeout(getAlarmCount, 5000);
}

function flickerAlarmIcon() {
    var alarmcount;

    alarmcount = parseInt(alarmCount);

    //菜单显示告警数量
    $("#alarmCount").html(alarmcount);

    //闪烁告警标志
    if (alarmcount > 0) {
        if (alarmIconFlg > 0) {
            $("#alarmIcon").css("visibility", "visible");
            alarmIconFlg = 0;
        } else {
            $("#alarmIcon").css("visibility", "hidden");
            alarmIconFlg = 1;
        }
    } else {
        $("#alarmIcon").css("visibility", "hidden");
    }
    
    // 告警音
    if(objctrl.buzzer) {
        if(alarmcount > 0) {
            var buzzer = document.getElementById("buzzer");
            if(buzzer.paused) {
                buzzer.paused = false;
                buzzer.play();
            }
        }else {
            var buzzer = document.getElementById("buzzer");
            if(buzzer.play) {
                buzzer.play = false;
                buzzer.pause();
            }
        }
    }
}


// 退出登录
function logoutSystem() {
    var userdata = { 'action': 1, 'data': 'logout' };

    $.ajax({
        url: 'projectSys.php',
        type: 'post',
        dataType: 'json',
        data: userdata,
        async: false,
        timeout: 5000,
        success: function(msg) {
            if (msg) {
                window.location.href = "login.html";
            }
        },
        error: function(errMsg) {}
    });
}